package cn.com.qmth.scancloud;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;

import com.github.jeffreyning.mybatisplus.conf.EnableMPP;
import com.qmth.boot.core.retrofit.annotatioin.RetrofitScan;

import cn.com.qmth.scancloud.client.MarkingcloudApiConfiguration;
import cn.com.qmth.scancloud.client.MarkingcloudProperties;

@EnableMPP
@SpringBootApplication
@EnableAsync
@EnableScheduling
@Configuration
@MapperScan("cn.com.qmth.scancloud.dao")
@RetrofitScan("cn.com.qmth.scancloud.client")
public class ApiApplication {

    public static void main(String[] args) {
        SpringApplication.run(ApiApplication.class, args);
    }

    @Bean
    public MarkingcloudApiConfiguration apiConfiguration(MarkingcloudProperties p) {
        return new MarkingcloudApiConfiguration(p);
    }

}
