package cn.com.qmth.scancloud.controller.admin;

import cn.com.qmth.scancloud.bean.CardAnswerDomain;
import cn.com.qmth.scancloud.bean.WorkloadDomain;
import cn.com.qmth.scancloud.controller.BaseController;
import cn.com.qmth.scancloud.service.BatchService;
import cn.com.qmth.scancloud.service.ScannerCardService;
import cn.com.qmth.scancloud.service.ScannerService;
import cn.com.qmth.scancloud.service.SystemConfigService;
import cn.com.qmth.scancloud.vo.ScannerWorkloadVo;
import cn.com.qmth.scancloud.vo.UpdateCountVo;
import cn.com.qmth.scancloud.vo.scannerinfo.Control;
import cn.com.qmth.scancloud.vo.scannerinfo.ScannerInfoVo;
import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.annotation.BOOL;
import com.qmth.boot.api.constant.ApiConstant;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@Api(tags = "扫描员管理接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/admin/scanner")
@Aac(strict = BOOL.FALSE, auth = BOOL.TRUE)
public class ScannerController extends BaseController {

    @Autowired
    private ScannerService scannerService;

    @Autowired
    private ScannerCardService scannerCardService;

    @Autowired
    private BatchService batchService;

    @Autowired
    private SystemConfigService systemConfigService;

    @ApiOperation(value = "扫描员管理详情")
    @PostMapping("info")
    public ScannerInfoVo scannerInfo(@RequestParam Long examId) {
        return scannerService.scannerInfo(examId);
    }

    @ApiOperation(value = "扫描员工作量统计")
    @PostMapping("workload")
    public List<ScannerWorkloadVo> workload(WorkloadDomain domain) {
        return batchService.workload(domain);
    }

    @ApiOperation(value = "修改扫描员登陆控制")
    @PostMapping("control")
    public Control control(Control control) {
        return systemConfigService.control(control);
    }

    @ApiOperation(value = "修改扫描员绑定卡格式")
    @PostMapping("card/answer")
    public UpdateCountVo cardAnswer(CardAnswerDomain domain) {
        return scannerCardService.cardAnswer(domain);
    }
}