package cn.com.qmth.scancloud.controller.scan;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.boot.api.utils.RequestUtil;

import cn.com.qmth.scancloud.bean.ScannerLoginInfo;
import cn.com.qmth.scancloud.controller.BaseController;
import cn.com.qmth.scancloud.service.AuthService;
import cn.com.qmth.scancloud.vo.ScannerLoginVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "扫描员登录接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/scan")
public class ScannerAuthController extends BaseController {

    @Autowired
    private AuthService authService;

    @ApiOperation(value = "扫描员登录")
    @PostMapping("login")
    public ScannerLoginVo login(ScannerLoginInfo loginInfo, HttpServletRequest request) {
        String ip = RequestUtil.getIpAddress(request);
        return ScannerLoginVo.of(authService.login(ip, loginInfo));
    }

}