package cn.com.qmth.scancloud.entity;

import cn.com.qmth.scancloud.entity.base.AuditingWithoutIdEntity;
import cn.com.qmth.scancloud.enums.CardSource;

import java.util.List;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.github.jeffreyning.mybatisplus.anno.MppMultiId;

// 试卷卡格式
@TableName(value="sc_answer_card", autoResultMap = true)
public class AnswerCardEntity extends AuditingWithoutIdEntity {

    private static final long serialVersionUID = -7904338527706136352L;

    @MppMultiId
    private Long examId;

    @MppMultiId
    private Integer number;

    // 可选
    private String subjectCode;

    private String subjectName;

    private Integer paperCount;

    private String path;

    private String md5;

    private CardSource source;

    private Boolean needAdapte;

    private Boolean singlePage;

    private String parameter;

    private String sliceConfig;
    
    @TableField(value = "slice_name", typeHandler = JacksonTypeHandler.class)
    private List<String> sliceName;

    private String remark;

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public Integer getNumber() {
        return number;
    }

    public void setNumber(Integer number) {
        this.number = number;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public Integer getPaperCount() {
        return paperCount;
    }

    public void setPaperCount(Integer paperCount) {
        this.paperCount = paperCount;
    }

    public String getPath() {
        return path;
    }

    public void setPath(String path) {
        this.path = path;
    }

    public String getMd5() {
        return md5;
    }

    public void setMd5(String md5) {
        this.md5 = md5;
    }

    public Boolean getSinglePage() {
        return singlePage;
    }

    public void setSinglePage(Boolean singlePage) {
        this.singlePage = singlePage;
    }

    public String getParameter() {
        return parameter;
    }

    public void setParameter(String parameter) {
        this.parameter = parameter;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public CardSource getSource() {
        return source;
    }

    public void setSource(CardSource source) {
        this.source = source;
    }

    public Boolean getNeedAdapte() {
        return needAdapte;
    }

    public void setNeedAdapte(Boolean needAdapte) {
        this.needAdapte = needAdapte;
    }

    public String getSliceConfig() {
        return sliceConfig;
    }

    public void setSliceConfig(String sliceConfig) {
        this.sliceConfig = sliceConfig;
    }

    
    public List<String> getSliceName() {
        return sliceName;
    }

    public void setSliceName(List<String> sliceName) {
        this.sliceName = sliceName;
    }
    
}
