package cn.com.qmth.scancloud.multithread.producer;

import cn.com.qmth.scancloud.multithread.BatchProducer;
import cn.com.qmth.scancloud.multithread.consumer.UploadConsumer;
import cn.com.qmth.scancloud.service.SessionService;
import cn.com.qmth.scancloud.service.StudentService;
import cn.com.qmth.scancloud.vo.StudentUploadVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class UploadProducer extends BatchProducer<StudentUploadVo, UploadConsumer> {

    @Autowired
    private StudentService studentService;

    @Autowired
    private SessionService sessionService;

    @Override
    public List<StudentUploadVo> findOneBatchData(Map<String, Object> param) {
        Long schoolId = (Long) param.get("schoolId");
        if (sessionService.getSchoolSession(schoolId) == null) {
            return null;
        }
        return studentService.findToUpload(200, schoolId);
    }

}
