package cn.com.qmth.scancloud.service;

import cn.com.qmth.scancloud.bean.User;
import cn.com.qmth.scancloud.entity.AnswerCardEntity;
import cn.com.qmth.scancloud.vo.AnswerCardVo;
import com.github.jeffreyning.mybatisplus.service.IMppService;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

public interface AnswerCardService extends IMppService<AnswerCardEntity> {

    int getCountByExam(Long examId);

    AnswerCardEntity save(User user, Long examId, Integer number, String subjectCode, String parameter, String remark,
            Integer paperCount, Boolean singlePage, String md5, MultipartFile file);

    void delete(User user, Long examId, Integer number);

    List<AnswerCardVo> listByExamId(Long examId);

    List<AnswerCardVo> listByExamIdForScanner(Long examId, User scanner, String device);

    AnswerCardEntity findByExamAndNumber(Long examId, Integer number);

    void sync(User user, Long examId);

}
