package cn.com.qmth.scancloud.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.boot.core.collection.PageResult;
import com.qmth.boot.mybatis.query.BaseQuery;

import cn.com.qmth.scancloud.bean.ExamConfigDomain;
import cn.com.qmth.scancloud.bean.ImportExamDomain;
import cn.com.qmth.scancloud.bean.User;
import cn.com.qmth.scancloud.entity.ExamEntity;
import cn.com.qmth.scancloud.vo.ExamConfigVo;
import cn.com.qmth.scancloud.vo.ExamInitVo;
import cn.com.qmth.scancloud.vo.ExamRemoteVo;
import cn.com.qmth.scancloud.vo.ExamVo;
import cn.com.qmth.scancloud.vo.checkimage.RatioVo;
import cn.com.qmth.scancloud.vo.examinfo.ExamInfoVo;
import cn.com.qmth.scancloud.vo.examinfo.ExamQuery;
import cn.com.qmth.scancloud.vo.scanexaminfo.ScanExamInfoVo;
import cn.com.qmth.scancloud.vo.scanexamlist.ScanExamListVo;

public interface ExamService extends IService<ExamEntity> {

    PageResult<ExamVo> pageQuery(ExamQuery query, User user);

    ExamInfoVo getExamInfoVo(Long id, User accessUser);

    List<ScanExamListVo> getScanExamList();

    PageResult<ExamRemoteVo> listRemote(BaseQuery<?> query, User accessUser);

    ScanExamInfoVo getScanExamInfo(Long id, User accessUser);

    ExamConfigVo config(User user, ExamConfigDomain domain);

    Double syncProgress(User user, Long examId);

    void sync(User user, Long examId);

    ExamInitVo init(User user, ExamConfigDomain domain);

    ExamEntity save(ImportExamDomain exam);

    RatioVo updateRatio(Long examId, Double ratio);
    
    void updateDataSyncTime(Long examId);
    
    void updateCardSyncTime(Long examId);
    

}
