package cn.com.qmth.scancloud.service;

import cn.com.qmth.scancloud.bean.User;
import cn.com.qmth.scancloud.entity.OmrGroupEntity;
import cn.com.qmth.scancloud.entity.OmrTaskEntity;
import cn.com.qmth.scancloud.enums.TaskStatus;
import cn.com.qmth.scancloud.vo.task.TaskResultVo;
import cn.com.qmth.scancloud.vo.task.TaskSaveVo;
import cn.com.qmth.scancloud.vo.task.TaskStatusVo;
import cn.com.qmth.scancloud.vo.task.TaskVo;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

public interface OmrTaskService extends IService<OmrTaskEntity> {

    int getCountByExam(Long examId);

    int getCountByExamAndStatus(Long examId, TaskStatus... status);

    int getCountByExamAndGroupAndStatus(Long examId, Long groupId, TaskStatus... status);

    void deleteByGroupId(Long groupId);

    void resetByGroup(OmrGroupEntity group);

    void saveTask(OmrGroupEntity group, Long studentId);

    TaskVo getTask(Long examId, String account);

    TaskSaveVo submitTask(TaskResultVo result, User user);

    TaskVo getArbitrateTask(Long examId, String user);

    TaskStatusVo getStatus(Long examId, Boolean isArbitrate, String account);

    boolean apply(OmrTaskEntity t, String account);

    void releaseByUser(Long examId, String account);

    void releaseByTask(OmrTaskEntity t);

    boolean hasApplied(OmrTaskEntity t, String account);

    List<OmrTaskEntity> findUnMarked(Long examId, int pageNumber, int pageSize, TaskStatus status);

    OmrTaskEntity getByPaperId(Long groupId, Long paperId);

    void waitingByGroupToggle(Long groupId);

    int getCountByExamAndStatusAndDevice(Long examId, String device, TaskStatus... status);

    void deleteByStudentId(Long examId, Long studentId);

    void updateStudentId(Long studentId, Long paperId);

    void rebuild(Long examId, Long studentId);

}
