package cn.com.qmth.scancloud.service.impl;

import cn.com.qmth.scancloud.config.SysProperty;
import cn.com.qmth.scancloud.entity.SystemConfigEntity;
import cn.com.qmth.scancloud.enums.SystemMode;
import cn.com.qmth.scancloud.multithread.producer.PictureCopyProducer;
import cn.com.qmth.scancloud.service.PictureCopyService;
import cn.com.qmth.scancloud.service.StudentService;
import cn.com.qmth.scancloud.service.SystemConfigService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class PictureCopyServiceImpl implements PictureCopyService {

    private static final Logger log = LoggerFactory.getLogger(PictureCopyService.class);

    @Autowired
    private PictureCopyProducer pictureCopyProducer;

    @Autowired
    private SysProperty sysProperty;

    @Autowired
    private SystemConfigService systemConfigService;

    @Autowired
    private StudentService studentService;

    @Override
    public void copy() {
        SystemConfigEntity conf = systemConfigService.findConfig();
        if (!SystemMode.STANDALONE.equals(conf.getSystemMode())) {
            return;
        }
        try {
            Integer count = sysProperty.getThreadCount();
            if (count == null) {
                count = 4;
            }
            if (studentService.existPictureCopyData()) {
                pictureCopyProducer.startDispose(count);
            }
        } catch (Exception e) {
            log.error("转存任务出错", e);
        }
    }
}
