package cn.com.qmth.scancloud.service.impl;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.boot.core.exception.ParameterException;
import com.qmth.boot.core.exception.StatusException;

import cn.com.qmth.scancloud.dao.SystemConfigDao;
import cn.com.qmth.scancloud.entity.SystemConfigEntity;
import cn.com.qmth.scancloud.service.SystemConfigService;
import cn.com.qmth.scancloud.vo.scannerinfo.Control;

@Service
public class SystemConfigServiceImpl extends ServiceImpl<SystemConfigDao, SystemConfigEntity> implements SystemConfigService {

	@Override
	public SystemConfigEntity findConfig() {
		SystemConfigEntity s=this.getById(1);
		if(s==null) {
			throw new StatusException("未初始化系统配置");
		}
        return s;
	}

	@Transactional
	@Override
	public Control control(Control control) {
		if (control.getEnableLogin() == null) {
            throw new ParameterException("EnableLogin不能为空");
        }
		if (control.getPassword()==null) {
            throw new ParameterException("Password不能为空");
        }
		SystemConfigEntity config=findConfig();
		config.setScannerEnableLogin(control.getEnableLogin());
		config.setScannerPassword(control.getPassword());
		this.saveOrUpdate(config);
		return control;
	}

}
